stages:
- prebuild
- install
- test
- compile
- build
  
variables:
  APP_ENV: ci

php-fpm:build:
  stage: prebuild
  image: docker:stable
  services:
    - docker:dind
  script:
    - IMAGE_NAME=$CI_REGISTRY_IMAGE/php-fpm:build
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker pull $IMAGE_NAME || true
    - docker build --cache-from $IMAGE_NAME -t $IMAGE_NAME -f docker/php-fpm/build/Dockerfile .
    - docker push $IMAGE_NAME
  only:
    - tags
    - web

composer:dev:
  stage: install
  image: %ci_registry_image%/php-fpm:build
  artifacts:
    expire_in: 20 mins
    paths:
      - vendor
      - .env
  script:
    - composer --version
    - composer install --prefer-dist --no-suggest --no-scripts
  only:
    - web
    - tags
    - merge_requests

npm:
  stage: install
  image: node:carbon-alpine
  artifacts:
    expire_in: 20 mins
    paths:
      - node_modules
  script:
    - npm -v && node -v
    - npm install
  only:
    - web
    - tags
    - merge_requests  

eslint:
  stage: test
  image: node:carbon-alpine
  dependencies:
    - npm
  script:
    - npm --version && node --version
    - npm run eslint
  only:
    - tags
    - web
    - merge_requests

phpunit:
  stage: test
  image: %ci_registry_image%/php-fpm:build
  script:
    - echo "Running unit tests"
    - composer run-script phpunit
  only:
    - tags
    - web
    - merge_requests
  dependencies:
    - composer:dev

phpstan:
  stage: test
  image: %ci_registry_image%/php-fpm:build
  dependencies:
    - composer:dev
  script:
    - composer run-script phpstan
  only:
    - web
    - tags
    - merge_requests

codesniffer:
  stage: test
  image: %ci_registry_image%/php-fpm:build
  dependencies:
    - composer:dev
  script:
    - composer run-script phpcs
  only:
    - web
    - tags
    - merge_requests

security-check:
  stage: test
  image: %ci_registry_image%/php-fpm:build
  script:
    - composer run-script security-check
  dependencies:
    - composer:dev
  only:
    - tags
    - web
    - merge_requests

assets:
  stage: compile
  image: node:carbon-alpine
  artifacts:
    expire_in: 20 mins
    paths:
      - public
  script:
    - npm -v && node -v
    - npm run production
  only:
    - web
    - tags

php-fpm:prod:
  stage: build
  image: docker:stable
  dependencies:
    - assets
    - composer:dev
  services:
    - docker:dind
  script:
    - IMAGE_NAME_CURRENT=$CI_REGISTRY_IMAGE/php-fpm:$CI_BUILD_REF_NAME
    - IMAGE_NAME_LATEST=$CI_REGISTRY_IMAGE/php-fpm:latest
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker pull $IMAGE_NAME_LATEST || true
    - docker build --cache-from $IMAGE_NAME_LATEST --build-arg PROJECT_REGISTRY_URL=$CI_REGISTRY_IMAGE -t $IMAGE_NAME_CURRENT -f docker/php-fpm/prod/Dockerfile .
    - docker push $IMAGE_NAME_CURRENT
    - if [ ! -z $CI_COMMIT_TAG ]; then
    -   echo "Commit tag set to $CI_COMMIT_TAG, tagging built image as latest."
    -   docker tag $IMAGE_NAME_CURRENT $IMAGE_NAME_LATEST
    -   docker push $IMAGE_NAME_LATEST
    - fi
  only:
    - web
    - tags

nginx:
  stage: build
  image: docker:stable
  dependencies:
    - assets
  services:
    - docker:dind
  script:
    - IMAGE_NAME_CURRENT=$CI_REGISTRY_IMAGE/nginx:$CI_BUILD_REF_NAME
    - IMAGE_NAME_LATEST=$CI_REGISTRY_IMAGE/nginx:latest
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker pull $IMAGE_NAME_LATEST || true
    - docker build --cache-from $IMAGE_NAME_LATEST -t $IMAGE_NAME_CURRENT -f docker/nginx/prod/Dockerfile .
    - docker push $IMAGE_NAME_CURRENT
    - if [ ! -z $CI_COMMIT_TAG ]; then
    -   echo "Commit tag set to $CI_COMMIT_TAG, tagging built image as latest."
    -   docker tag $IMAGE_NAME_CURRENT $IMAGE_NAME_LATEST
    -   docker push $IMAGE_NAME_LATEST
    - fi
  only:
    - web
    - tags
